;******************************************************************************************
;    PROGRAMME	:  Affiche.asm				
;    PROGRAMME ATTACHE : Regul.asm
;******************************************************************************************


;******************************************************************************************
;			Affichage des valeurs sur LCD
;******************************************************************************************
;	L'affichage se fait en fonction de :
;
;	N de page
;	Rgulation En ou Hors Service
;	Bruleur Autoris ou Non
;	Tempratures et valeurs stocks (Tambiant, cdc,...)
;
;	Registres Modifies : SREG
;******************************************************************************************
Aff_Valeurs:
	push zl
	push zh
	push r16
	
	mov r16,DRAPEAUX
	andi r16,0x03			; Lecture du n de page
	breq Aff_Normal			; Si 0 : Mode Normal
	rjmp Fin_Aff_Valeurs		; Pas de valeur en page mode
	
;--------------------- Page 0 : Mode Normal -----------------------------------------------	
Aff_Normal:
	sbrs DRAPEAUX,2			; Regulation  l'arrt ?
	rjmp Aff_Arret			; Oui va  la page arrt
	
	sbrs DRAPEAUX,3			; Bruleur en repos ?
	rjmp Aff_Repos			; Oui va  repos	

	sbrc DRAPEAU2,4		; Saut si mode auto
	rjmp TC			; Sinon n'affiche pas la consigne ambiante

	ldi r16,0x8C
	rcall PROG_LCD		; Place curseur
	lds r16,Cons_Amb
	rcall Aff_Temp_Decimal	; Affiche consigne Ambiante

TC:
	ldi r16,0x84
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Amb
	rcall Aff_Temp_Decimal	; Affiche temprature Ambiante

	ldi r16,0xC4
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Cdc
	rcall Aff_Temp_Decimal	; Affiche temprature corps de chauffe

	ldi r16,0xCC
	rcall PROG_LCD		; Place curseur
	lds r16,Cons_Cdc
	rcall Aff_Temp_Decimal	; Affiche consigne corps de chauffe
	rjmp Fin_Aff_Ecran

Aff_Repos:	
	ldi r16,0x84
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Amb
	rcall Aff_Temp_Decimal	; Affiche temprature Ambiante

	ldi r16,0x8C
	rcall PROG_LCD		; Place curseur
	lds r16,Cons_Amb
	rcall Aff_Temp_Decimal	; Affiche consigne Ambiante
	rjmp Fin_Aff_Ecran

Aff_Arret:
	ldi r16,0x8C
	rcall PROG_LCD		; Place curseur
	lds r16,L_Temp_Amb
	rcall Aff_Temp_Decimal	; Affiche temprature Ambiante
	rjmp Fin_Aff_Valeurs


;--------------------- Page 2 : Page Mode  ---------------------------------------------	
; Rien ne se fait ici


Fin_Aff_Valeurs:
	pop r16
	pop zh
	pop zl
	ret



;******************************************************************************************
;			Affichage l'Ecran LCD
;******************************************************************************************
;	L'affichage se fait en fonction de :
;
;	N de page
;	Rgulation En ou Hors Service
;	Bruleur Autoris ou Non
;
;	Registres Modifies : SREG
;******************************************************************************************
Aff_Ecran:
	push zl
	push zh
	push r16
	
	mov r16,DRAPEAUX
	andi r16,0x03			; Lecture du n de page
	breq Page_Normal		; Si 0 : Mode Normal
	rjmp Page_Mode			; Mode de fonctionnement
	
;--------------------- Page 0 : Mode Normal -----------------------------------------------	
Page_Normal:
	sbrs DRAPEAUX,2			; Regulation  l'arrt ?
	rjmp Page_Arret			; Oui va  la page arrt
	
	sbrs DRAPEAUX,3			; Bruleur en repos ?
	rjmp Repos			; Oui va  repos	

	sbrs DRAPEAU2,4			; Saut si mode auto
	rjmp Mauto			; Sinon Affiche mode manuel

	ldi zl,low(NORMAL10*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(NORMAL10*2)	
	rcall Aff_Lg1
	rjmp Mlg2
Mauto:
	ldi zl,low(NORMAL11*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(NORMAL11*2)	
	rcall Aff_Lg1

Mlg2:
	ldi zl,low(NORMAL2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(NORMAL2*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

Repos:
	ldi zl,low(NORMAL11*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(NORMAL11*2)	
	rcall Aff_Lg1

	ldi zl,low(REPOS2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(REPOS2*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

Page_Arret:
	ldi zl,low(ARRET1*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(ARRET1*2)	
	rcall Aff_Lg1

	ldi zl,low(ARRET2*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(ARRET2*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

;--------------------- Page 2 : Page Mode ---------------------------------------------	
Page_Mode:
	ldi zl,low(MODE1*2)		; Afficher la ligne 1 Ecran
	ldi zh,high(MODE1*2)	
	rcall Aff_Lg1
	
	sbrs DRAPEAU2,4			; Si mode manuel saut
	rjmp Pauto			; sinon mode automatique

	ldi zl,low(MODE20*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(MODE20*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran

Pauto:
	ldi zl,low(MODE21*2)		; Afficher la ligne 2 Ecran
	ldi zh,high(MODE21*2)	
	rcall Aff_Lg2
	rjmp Fin_Aff_Ecran


Fin_Aff_Ecran:
	sbrs DRAPEAUX,4			; Si mode test saut
	rjmp Pas_Test			; Sinon va  Pas_Test
	
	ldi r16,0x80
	rcall PROG_LCD			; Curseur  0
	ldi r16,0xFF
	rcall DATA_LCD			; Affiche un pav pour indiquer le mode test

Pas_test:
	pop r16
	pop zh
	pop zl
	ret


;******************************************************************************************
;			ECRAN LCD
;******************************************************************************************
;---------------------------- Page 0 ------------------------------------------------------
NORMAL10:.db "Amb:xx.x        ",0  ; Mode Manuel
NORMAL11:.db "Amb:xx.x co:xx.x",0  ; Mode auto
NORMAL2: .db "Eau:xx.x co:xx.x",0

;REPOS1:.db "Amb:xx.x co:xx.x",0 ; = Normal 11 donc inutile
REPOS2:	.db "*** En Repos ***",0

ARRET1:	.db "Temperature:xx.x",0
ARRET2:	.db "***** Arret ****",0

;---------------------------- Page 2 ------------------------------------------------------
MODE1:	.db "***** Mode *****",0
MODE20:	.db "     Manuel     ",0
MODE21: .db "  Automatique   ",0

