;******************************************************************************************
;    PROGRAMME	:  automat.asm				
;    PROGRAMME ATTACHE : Regul.asm
;******************************************************************************************

Trait_Auto:
	sbrc DRAPEAU2,3		; Saut si Fonctionnement Normal
	rjmp Demarrage
;----------------- Fonctionnement normal de l'automate ------------------------------------
Normal:
	lds r16,Cons_Amb	
	dec r16			; Lecture Cons_Amb-0,5C
	lds r17,L_Temp_Amb	; Lecture de la temprature
	cp r16,r17		; Tamb<=Cons_Amb-0,5C ?
	brsh Seuil_Bas		; Si seuil Bas dtect
		
	sbrs DRAPEAUX,3		; Saut si chauff=1
	rjmp Fin_Trait_Auto	; Sinon attente (pas de dtection de maxi)

	inc r16
	inc r16			; Cons_Amb+0,5C
	cp r17,r16		; Tamb>=Cons_Amb+0,5C
	brsh Seuil_Haut		; Si seuil haut dtect
Fin_JMP:
	rjmp Fin_Trait_Auto

Seuil_bas:
	sbrs DRAPEAUX,3		; Saut si chauff=1
	rjmp Reactiver_Ch 	; Sinon ractiver chauffage

	tst CpTemps		; Evaluation de situation toutes les  Tps_Evalx30mn
	brne Fin_JMP

	lds r16, Cons_Cdc	; Lire consigne Cdc
	ldi zh,high(TABLE_AJ_PLUS*2)
	ldi zl,low (TABLE_AJ_PLUS*2)
	add zl,Totaliseur	; Pointe sur l'ajustement de T  faire
	brne Fin_TabPlus
	inc zh			; Si Changement de page mmoire
Fin_TabPlus:
	lpm			; Lecture de la table
	add r16,r0		; Ajoute la consigne Cdc
	cpi r16,LIMITE_AQUA	; Consigne limite
	brlo NoLimitPlus	; Si < limite saut  NoLimit
	ldi r16,LIMITE_AQUA	; Sinon bloque  la limite
NoLimitPlus:
	sts Cons_Cdc,r16
	ldi r16,Tps_Eval	; CpTemps=30mn
	mov CpTemps,r16
	clr totaliseur
	clr Div_DemiHeures
	rjmp Fin_SB

Reactiver_Ch:
	sbr DRAPEAUX,0x08	; Chauff=1
	clr Totaliseur	
	clr Div_DemiHeures
	ldi r16,Tps_Eval
	mov CpTemps,r16		; Prochaine valuation dans Tps_Evalx30mn
	rcall Aff_Ecran		; Afficher l'cran

Fin_SB:
	rcall Aff_Valeurs
	rjmp Fin_Trait_Auto

Seuil_Haut:
	tst CpTemps		; Evaluation de situation toutes les  Tps_Evalx30mn
	brne Fin_JMP

	lds r16, Cons_Cdc	; Lire consigne Cdc
	ldi zh,high(TABLE_AJ_MOINS*2)
	ldi zl,low (TABLE_AJ_MOINS*2)
	add zl,Totaliseur	; Pointe sur l'ajustement de T  faire
	brne Fin_TabMoins
	inc zh			; Si Changment de page mmoire
Fin_TabMoins:
	lpm			; Lecture de la table
	sub r16,r0		; Enlve la valeur d'ajustement
	lds r17,Cons_Amb
	ldi r18,LIMITE_BASSE_AQUA
	add r17,r18		; Cons_Amb+LIMITE_BASSE_AQUA=limite basse aquastat
	cp r17,r16		; Cdc>ConsAmb+Limite basse aquastat 
	brlo PasTropMoins	; si consigne pas trop faible
	lds r16,Cons_Amb
	ldi r17,18
	add r16,r17		; Cdc=Cons_Amb+9C
	sts Cons_Cdc,r16
	cbr DRAPEAUX,0x08	; Chauff=0
	rcall Aff_Ecran	
	rjmp Fin_SP

PasTropMoins:
	sts Cons_Cdc,r16
	ldi r16,Tps_Eval	; Attendre Tps_Evalx30mn avant prochaine modif consigne
	mov Cptemps,r16
	clr Totaliseur		; Totaliseur=0
	clr Div_DemiHeures
Fin_SP:
	rcall Aff_Valeurs
	rjmp Fin_Trait_Auto

;----------------- Dmarrage de l'automate ------------------------------------------------
Demarrage:
	sbrs DRAPEAU2,2		; Saut si rglages  effectuer
	rjmp Dem_Regul		; Sinon rgulation du dmmarage
Regler:
	cbr DRAPEAU2,0x04	; Bit Regl=0
	lds r16,L_Temp_Amb
	lds r17,Cons_Amb	; Lecture Consigne
	dec r17			; Consigne Ambiante-0,5C (hystresis)
	cp r16,r17		; Test si Tamb>=ConsAmb-0,5C (Pice dja chaude)
	brge Piece_Chaude
Piece_Froide:
	sub r17,r16		; ConsAmb-0,5C-TempAmb= Dcalage de T
	ldi zh,high(TABLE_DEM*2)
	ldi zl,low(TABLE_DEM*2)
	sbrc r17,0		; Saut si xx.0C
	inc r17			; Si xx.5C limine le demi degr en passant  l'entier suprieur
	lsr r17			; Enlve le demi dgrs
	cpi r17,6
	brlo inf5		; Branche si r17 est <6 (<=5)
	ldi r17,0x05		; Si cart >=6C on prend cart=5C
inf5:
	dec r17
	add zl,r17
	brne suit
	inc zh
suit:
	lpm			; lire valeur
	sts Cons_Cdc,r0		; Sauver consigne
	ldi r16,2
	mov CpTemps,r16		; CpTemps = 2x30mn = 1h
	clr Totaliseur		; Totaliseur=0;
	clr Div_DemiHeures	
	rjmp Fin_Trait_Auto

Piece_Chaude:
	cbr DRAPEAUX,0x08	; Bit Chauff=0 (pas de bruleur)
	cbr DRAPEAU2,0x0C	; Bit Dem=0; Regl=0 (Dmarrage fini)
	lds r16,Cons_Amb
	ldi r17,18
	add r16,r17		
	sts Cons_Cdc,r16	; Cons_Cdc=Cons_Amb + 9C	
	clr CpTemps
	rcall Aff_Ecran		; Affiche Ecran en mode repos
	rcall Aff_Valeurs	; Afficher les valeurs
	rjmp Fin_Trait_Auto

Dem_Regul:
	tst CpTemps		; Si le temps n'est pas coule
	brne Temps_Pas_Ecoule	; saut
	lds r17, Cons_Cdc
	ldi r16,10
	add r17,r16		; Ajoute 5C  la consigne
	cpi r17,LIMITE_AQUA	; Consigne limite
	brlo NoLimit		; Si < limite saut  NoLimit
	ldi r17,LIMITE_AQUA	; Sinon bloque  la limite
NoLimit:
	sts Cons_Cdc,r17
	ldi r16,1		; CpTemps=30mn
	mov CpTemps,r16
	rcall Aff_Valeurs	; Affiche la nouvelle consigne
	rjmp Fin_Trait_Auto

Temps_Pas_Ecoule:
	lds r16,L_Temp_Amb
	lds r17,Cons_Amb	; Lecture Consigne
	dec r17			; Consigne Ambiante-0,5C (hystresis)
	cp r16,r17		; Test si Tamb<ConsAmb-0,5C (Pice pas assez chaude)
	brlo Fin_Trait_Auto
Terminer_le_Demarrage:
	lds r16, Cons_Cdc	; Lire consigne Cdc
	cbr DRAPEAU2,0x08	; Bit Dem=0 (Dmarrage fini)
	ldi zh,high(TABLE_AJ_DEM*2)
	ldi zl,low (TABLE_AJ_DEM*2)
	add zl,Totaliseur	; Pointe sur l'ajustement de T  faire
	brne Fin_dem
	inc zh			; Si Changment de page mmoire
Fin_dem:
	lpm			; Lecture de la table
	sub r16,r0		; Diminue la consigne Cdc
	lds r17,Cons_Amb
	ldi r18,18
	add r17,r18		; Cons_Amb+9C = limite basse aquastat
	cp r17,r16		; Cdc>ConsAmb+9C 
	brlo PasTropBas		; si consigne trop faible
	mov r16,r17		; Cdc=Cons_Amb+9C
PasTropBas:
	sts Cons_Cdc,r16
	ldi r16,Tps_Eval	; Attendre Tps_Evalx30mn avant prochaine modif consigne
	mov Cptemps,r16
	clr Totaliseur		; Totaliseur=0
	clr Div_DemiHeures
	cbr DRAPEAU2,0x08	; Bit Dem=0 (Dmarrage fini)
	rcall Aff_Valeurs

Fin_Trait_Auto:
	ret


;******************************************************************************************
;			TABLE DES TEMPERATURES
;******************************************************************************************
;---------------------------- Consigne de Dmarrage ---------------------------------------
TABLE_DEM:	       .db 60, 68, 76, 84, 90
; Dcalage de temprature : 1  2  3  4  5
; Consigne CDC  appliquer 30 34 38 42 45

;---------------------------- Ajustement  l'atteinte de la Cons_Amb-0,5C ----------------
TABLE_AJ_DEM:		 .db 24,   20,   20,   12,   12,   6,    6,     4
; Ajustement de Temprature: 12   10   10   6    6    3    3     2
; Temps coul depuis dem  : 30'   1h    1h30' 2h    2h30' 3h    3h30   +4h

;---------------------------- Ajustement en monte de temprature  ------------------------
TABLE_AJ_PLUS:		 .db  8,    8,    7,   7,    6,    5,    4,     2
; Ajustement de Temprature:  4    4   3,5  3,5  3   2,5   2     1
; Temps Totaliseur         : 30'   1h    1h30' 2h    2h30' 3h    3h30   +4h

;---------------------------- Ajustement en descente de temprature --------------------
TABLE_AJ_MOINS:		 .db  6,    6,    4,   4,    3,    3,    2,     2
; Ajustement de Temprature:  3    3    2   2    1,5  1,5  1     1
; Temps Totaliseur	   : 30'   1h    1h30' 2h    2h30' 3h    3h30   +4h